#!/usr/local/bin/perl5 -w

# Check registration list.

use strict;

use CGI ':standard';
use CGI::Carp 'fatalsToBrowser';

use POSIX;
use Fcntl ':flock';
use MLDBM qw(DB_File Storable);

# FMC better place?
use lib '.';
use TestBase;

# Base name of user database.
use constant USERFILE => 'users.db';

### Main

my $dbfile = COURSEDIR . '/' . USERFILE;
my %db;
{
  my $db = tie(%db, 'MLDBM',
               $dbfile,
               O_RDONLY)
    or die "User database $dbfile: $!";
  my $fd = $db->fd;
  open(DB_FH, "<&=$fd") or die "dup $fd: $!";
  flock(DB_FH, LOCK_SH);

  print
    header(-pragma => 'no-cache',
           -type => 'text/plain');
  while (my ($ip, $user) = each %db) {
    print $ip, ' ', $user, "\n";
  }

  flock(DB_FH, LOCK_UN);
}
untie %db;


### End main
